
---
image: docker:25.0.3 # The default image the will be used for running the job in the pipeline

services: ['docker:25.0.3-dind'] # The additional image is used to create another container, which is available to the first container. The two containers have access to one another and can communicate when running the job. 

#
# Pipeline cache is based on CI_COMMIT_REF_SLUG.
#
cache:
  key: ${CI_COMMIT_REF_SLUG}


#
# Static script to be reused by the enabled stages.
#

.apk-before-script: &apk-before-script
  # Install required apk packages.
  - apk add --update bash wget ca-certificates openssl git tar openssh-client curl python3 py3-pip




#
# Stages to run.
#

stages:
  - test
  - build


unit:production: # the unit test job for the proiduction environment
  stage: test
  image: python:3.11 # the image the will be runned in the pipeline
  script: # the commands to run in the stage
    - TODO run unit test
  needs: []
  only:
    - tags # The stage will run only on tagged commits


coverage:production: # the test coverage job for the production environment
  stage: test
  coverage: '/^TOTAL.+?(\d+\%)$/' # the regexp used for parsing the coverage results
  image: python:3.11
  allow_failure: true # the stage may fail withouth set the whole pipeline as failed
  script:
    - TODO run coverage
  artifacts: # The coverage report will be saved as pipeline artifact
    when: always
    reports:
      junit: src/report.xml
      coverage_report:
        coverage_format: cobertura
        path: src/coverage.xml
  needs: []
  only:
    - tags # The stage will run only on tagged commits

docker image:production: # this job will build a docker image starting from the repository and it will upload it to the gitlab container registry dedicated to the project https://gitlab.com/tango-ecosystem/code-camp/restapi-exercise/container_registry
  # This job is leaveraging the docker:25.0.3-dind (dind stads for docker-in-docker) service defined above in order to handle docker images
  stage: build
  script:
    - *apk-before-script

    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY

    - docker build -t $CI_REGISTRY/tango-ecosystem/code-camp/restapi-exercise:latest .
    - docker push $CI_REGISTRY/tango-ecosystem/code-camp/restapi-exercise:latest
  needs: 
    - unit:production # this job will run only if the job unit:production is a success
  only:
    - tags # The stage will run only on tagged commits


unit:mr: # the unit test job for the merge request environment
  stage: test
  image: python:3.11
  script:
    - TODO run unit test
  needs: []
  only:
    - merge_requests # The pipeline will run only on commits connected to a merge request


coverage:mr: # the coverage job for the merge request environment
  stage: test
  coverage: '/^TOTAL.+?(\d+\%)$/'
  image: python:3.11
  allow_failure: true
  script:
    - TODO run coverage
  artifacts:
    when: always
    reports:
      junit: src/report.xml
      coverage_report:
        coverage_format: cobertura
        path: src/coverage.xml
  needs: []
  only:
    - merge_requests # The pipeline will run only on commits connected to a merge request

lint:mr: # The linting job for the merge request environment
  stage: test
  image: python:3.11
  allow_failure: False
  script:
    - python -v
    - python -m venv venv
    - source venv/bin/activate
    - pip install --upgrade pip
    - pip install -r requirements.txt
    - pip install flake8
    - flake8 --ignore E501,W504,E241,F405,F403 src
  cache:
    paths:
      - .cache/pip
      - venv/
  needs: []
  only:
    - merge_requests # The pipeline will run only on commits connected to a merge request